/*!
 * PubSub
 * Javascript implementation of the Publish/Subscribe pattern.
 *
 * @version v4.0.1
 * @author George Raptis <georapbox@gmail.com>
 * @homepage https://github.com/georapbox/PubSub#readme
 * @repository https://github.com/georapbox/PubSub.git
 * @license MIT
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):(e="undefined"!=typeof globalThis?globalThis:e||self).PubSub=t()}(this,(function(){"use strict";function e(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}function t(e,t,r){return t in e?Object.defineProperty(e,t,{value:r,enumerable:!0,configurable:!0,writable:!0}):e[t]=r,e}function r(e,t){var r=Object.keys(e);if(Object.getOwnPropertySymbols){var n=Object.getOwnPropertySymbols(e);t&&(n=n.filter((function(t){return Object.getOwnPropertyDescriptor(e,t).enumerable}))),r.push.apply(r,n)}return r}function n(e){for(var n=1;n<arguments.length;n++){var o=null!=arguments[n]?arguments[n]:{};n%2?r(Object(o),!0).forEach((function(r){t(e,r,o[r])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(o)):r(Object(o)).forEach((function(t){Object.defineProperty(e,t,Object.getOwnPropertyDescriptor(o,t))}))}return e}function o(e){return function(e){if(Array.isArray(e))return i(e)}(e)||function(e){if("undefined"!=typeof Symbol&&Symbol.iterator in Object(e))return Array.from(e)}(e)||function(e,t){if(!e)return;if("string"==typeof e)return i(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);"Object"===r&&e.constructor&&(r=e.constructor.name);if("Map"===r||"Set"===r)return Array.from(e);if("Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r))return i(e,t)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function i(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,n=new Array(t);r<t;r++)n[r]=e[r];return n}var u=function(e,t,r){for(var n in e)if(Object.prototype.hasOwnProperty.call(e,n)&&t&&!1===t.call(r,e[n],n,e))return;return e},c=function(e,t,r){for(var n=r._pubsub_topics,i=n[e]?o(n[e]):[],u=0,c=i.length;u<c;u+=1){var a=i[u].token,s=i[u];if(r._options.immediateExceptions)s.callback(t,{name:e,token:a});else try{s.callback(t,{name:e,token:a})}catch(e){setTimeout((function(){throw e}),0)}!0===s.once&&r.unsubscribe(a)}},a=function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];return r.length<=1?r[0]:[].concat(r)},s=function(e,t,r,n){return!!e._pubsub_topics[t]&&(n?c(t,r,e):setTimeout((function(){c(t,r,e)}),0),!0)},f=function(){function t(e){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,t);this._pubsub_topics={},this._pubsub_uid=-1,this._options=n(n({},{immediateExceptions:!1}),e)}var r,i,c;return r=t,i=[{key:"subscribe",value:function(e,t,r){var n=this._pubsub_topics,o=this._pubsub_uid+=1,i={};if("function"!=typeof t)throw new TypeError("When subscribing for an event, a callback function must be defined.");return n[e]||(n[e]=[]),i.token=o,i.callback=t,i.once=!!r,n[e].push(i),o}},{key:"subscribeOnce",value:function(e,t){return this.subscribe(e,t,!0)}},{key:"publish",value:function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];return s(this,e,a.apply(void 0,[e].concat(r)),!1)}},{key:"publishSync",value:function(e){for(var t=arguments.length,r=new Array(t>1?t-1:0),n=1;n<t;n++)r[n-1]=arguments[n];return s(this,e,a.apply(void 0,[e].concat(r)),!0)}},{key:"unsubscribe",value:function(e){var t=this._pubsub_topics,r=!1;for(var n in t)if(Object.prototype.hasOwnProperty.call(t,n)&&t[n]){for(var o=t[n].length;o;){if(o-=1,t[n][o].token===e)return t[n].splice(o,1),0===t[n].length&&delete t[n],e;n===e&&(t[n].splice(o,1),0===t[n].length&&delete t[n],r=!0)}if(!0===r)return e}return!1}},{key:"unsubscribeAll",value:function(){return this._pubsub_topics={},this}},{key:"hasSubscribers",value:function(e){var t=this._pubsub_topics,r=!1;return null==e?(u(t,(function(e,t){if(t)return r=!0,!1})),r):Object.prototype.hasOwnProperty.call(t,e)}},{key:"subscribers",value:function(){var e={};return u(this._pubsub_topics,(function(t,r){e[r]=o(t)})),e}},{key:"subscribersByTopic",value:function(e){return this._pubsub_topics[e]?o(this._pubsub_topics[e]):[]}},{key:"alias",value:function(e){var r=this;return u(e,(function(n,o){var i,u;t.prototype[o]&&(t.prototype[e[o]]=(i=o,u=r,function(){for(var e=arguments.length,t=new Array(e),r=0;r<e;r++)t[r]=arguments[r];return u[i].apply(u,t)}))})),this}}],i&&e(r.prototype,i),c&&e(r,c),t}();return f.createInstance=function(e){return new f(e)},f}));
